package com.tmax.openframe;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.file.*;
import com.tmax.openframe.variable.OFCB001_VariableContainer;
import com.tmax.openframe.variable.group.*;
import java.lang.Runnable;
import java.math.*;
import java.time.LocalDate;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 * <dl>
 * </dl>
 * <p>This describes files what declared in I/O sections: </p>
 * <ul>
 * <li>
 * IN-CUSTOMER-FILE: file class {@code ->} {@link OFCB001_FD_IN_CUSTOMER_FILE}, record class {@code -> } {@link OFCB001_IN_REC}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * OUT-NEW-CUSTOMERS: file class {@code ->} {@link OFCB001_FD_OUT_NEW_CUSTOMERS}, record class {@code -> } {@link OFCB001_OUT_REC}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * </ul>
 */
public class OFCB001 implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OFCB001_VariableContainer container = new OFCB001_VariableContainer();
    OFCB001_FD_IN_CUSTOMER_FILE FD_IN_CUSTOMER_FILE;
    OFCB001_FD_OUT_NEW_CUSTOMERS FD_OUT_NEW_CUSTOMERS;
    Runnable INITIALIZATION = this::INITIALIZATION;
    Runnable MAINLINE = this::MAINLINE;
    Runnable FINALIZATION = this::FINALIZATION;
    Runnable _1000_READ = this::_1000_READ;
    Runnable _1000_READ_EXIT = this::_1000_READ_EXIT;
    Runnable _2000_MAINLINE_PROC = this::_2000_MAINLINE_PROC;
    Runnable _2000_MAINLINE_EXIT = this::_2000_MAINLINE_EXIT;
    Runnable _3000_WRITE = this::_3000_WRITE;
    Runnable _3000_WRITE_EXIT = this::_3000_WRITE_EXIT;
    Runnable _9000_DISPLAY_STATISTICS = this::_9000_DISPLAY_STATISTICS;
    Runnable _9000_DISPLAY_STATISTICS_EXIT = this::_9000_DISPLAY_STATISTICS_EXIT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(INITIALIZATION);
        MethodFlow.add(MAINLINE);
        MethodFlow.add(FINALIZATION);
        MethodFlow.add(_1000_READ);
        MethodFlow.add(_1000_READ_EXIT);
        MethodFlow.add(_2000_MAINLINE_PROC);
        MethodFlow.add(_2000_MAINLINE_EXIT);
        MethodFlow.add(_3000_WRITE);
        MethodFlow.add(_3000_WRITE_EXIT);
        MethodFlow.add(_9000_DISPLAY_STATISTICS);
        MethodFlow.add(_9000_DISPLAY_STATISTICS_EXIT);
    }

    public OFCB001() {
        FD_IN_CUSTOMER_FILE = new OFCB001_FD_IN_CUSTOMER_FILE();
        FD_OUT_NEW_CUSTOMERS = new OFCB001_FD_OUT_NEW_CUSTOMERS();
    }

    public @Override void run() {
        run(INITIALIZATION, _9000_DISPLAY_STATISTICS_EXIT);
    }

    private void run(Runnable start) {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    public void init() {
        container = new OFCB001_VariableContainer();
        FD_IN_CUSTOMER_FILE = new OFCB001_FD_IN_CUSTOMER_FILE();
        FD_OUT_NEW_CUSTOMERS = new OFCB001_FD_OUT_NEW_CUSTOMERS();
    }

    void INITIALIZATION() {
        container.setW_TODAY_DATE(Integer.parseInt(LocalDate.now()
                .format(DateTimeFormatter.ofPattern("yyyyMMdd")).trim()));
    }

    void MAINLINE() {
        run(_1000_READ, _1000_READ_EXIT);
        if (GoTo != null || Return) {
            return;
        }
        while (!(StringUtils.stripEnd(container.getEOF_SW(), " ")
                .compareTo("Y") == 0)) {
            run(_2000_MAINLINE_PROC, _2000_MAINLINE_EXIT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void FINALIZATION() {
        run(_9000_DISPLAY_STATISTICS);
        if (GoTo != null || Return) {
            return;
        }
        FD_IN_CUSTOMER_FILE.close();
        FD_OUT_NEW_CUSTOMERS.close();
        Return = true;
        return;
    }

    void _1000_READ() {
        OFCB001_IN_REC temp_OFCB001_IN_REC1;
        temp_OFCB001_IN_REC1 = FD_IN_CUSTOMER_FILE.readNext();
        if (temp_OFCB001_IN_REC1 != null) {
            container.setIN_REC(temp_OFCB001_IN_REC1);
        } else if (FD_IN_CUSTOMER_FILE.getFileStatus() == FileStatus.AT_END_CONDITION_SEQUENCED) {
            container.setEOF_SW("Y");
        }
        if (StringUtils.stripEnd(container.getEOF_SW(), " ").compareTo("Y") != 0) {
            container.setREAD_COUNT(container.getREAD_COUNT() + 1);
        }
    }

    void _1000_READ_EXIT() {
    }

    void _2000_MAINLINE_PROC() {
        if (container.getIN_REC().getIN_LAST_UPDATE() == container
                .getW_TODAY_DATE()) {
            run(_3000_WRITE, _3000_WRITE_EXIT);
            if (GoTo != null || Return) {
                return;
            }
            container.setWRITE_COUNT(container.getWRITE_COUNT() + 1);
        } else {
            container.setPASS_COUNT(container.getPASS_COUNT() + 1);
        }
        run(_1000_READ, _1000_READ_EXIT);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _2000_MAINLINE_EXIT() {
    }

    void _3000_WRITE() {
        container.setOUT_REC(OFCB001_OUT_REC.createDefaultValueInstance());
        container.getOUT_REC().setOUT_CUSTOMER_NUMBER(
                container.getIN_REC().getIN_CUSTOMER_NUMBER());
        container.getOUT_REC().setOUT_FIRST_NAME(
                container.getIN_REC().getIN_FIRST_NAME());
        container.getOUT_REC().setOUT_LAST_NAME(
                container.getIN_REC().getIN_LAST_NAME());
        container.getOUT_REC().setOUT_LAST_UPDATE(
                container.getIN_REC().getIN_LAST_UPDATE());
        FD_OUT_NEW_CUSTOMERS.write(container.getOUT_REC());
    }

    void _3000_WRITE_EXIT() {
    }

    void _9000_DISPLAY_STATISTICS() {
        System.out.println("<====== OFBM001 COUNTS ==========>");
        System.out.print("READ   COUNT : ");
        System.out.println(container.getREAD_COUNT());
        System.out.print("WRITE  COUNT : ");
        System.out.println(container.getWRITE_COUNT());
        System.out.print("PASS   COUNT : ");
        System.out.println(container.getPASS_COUNT());
        System.out.println("<================================>");
    }

    void _9000_DISPLAY_STATISTICS_EXIT() {
    }
}
